import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { NewBrandComponent } from './new-brand/new-brand.component';
import { AddnewBrandComponent } from './addnew-brand/addnew-brand.component';
import { AddnewCampaignComponent } from './addnew-campaign/addnew-campaign.component';
import { CampaignNewComponent } from './campaign-new/campaign-new.component';
import { CnpCampaignNewComponent } from './cnp-campaign-new/cnp-campaign-new.component';
import { CnpSettingNewComponent } from './cnp-setting-new/cnp-setting-new.component';
import { RegisternewCampaignComponent } from './registernew-campaign/registernew-campaign.component';
import { NewBrandDetailsComponent } from './new-brand-details/new-brand-details.component';
import { NewcampaignDetailsComponent } from './newcampaign-details/newcampaign-details.component';
import { CnpBrandComponent } from './cnp-brand/cnp-brand.component';
const routes: Routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: CampaignNewComponent,
                data: {
                    title: 'new-campaign',
                    urls: [
                        {
                            title: 'A2P Campaign',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Campaign'
                        }
                    ]
                }
            },
            {
                path: 'brand',
                component: NewBrandComponent,
                data: {
                    title: 'Brands',
                    urls: [
                        {
                            title: 'Brand',

                        },
                        {
                            title: ' Brand Details'
                        }
                    ]
                }
            },

            {
                path: 'add_Brand',
                component: AddnewBrandComponent,
                data: {
                    title: 'add Brand',
                    urls: [
                        {
                            title: ' Campaign',

                        },
                        {
                            title: 'Add Brand'
                        }
                    ]
                }
            },

            {
                path: 'add_brand/:register',
                component: AddnewBrandComponent,
                data: {
                    title: 'Register Brand',
                    urls: [
                        {
                            title: 'Brand',

                        },
                        {
                            title: 'Register Brand'
                        }
                    ]
                }
            },
            {
              path: 'cnp_brand',
              component: CnpBrandComponent,
              data: {
                  title: 'CNP Brand',
                  urls: [
                      {
                          title: 'CNP Brand',

                      },
                      {
                          title: 'CNP Brand'
                      }
                  ]
              }
          },
            {
                path: 'cnp_campaign',
                component: CnpCampaignNewComponent,
                data: {
                    title: 'CNP Campaign',
                    urls: [
                        {
                            title: 'CNP Campaign',

                        },
                        {
                            title: 'CNP Campaign'
                        }
                    ]
                }
            },

            {
                path: 'cnp_setting',
                component: CnpSettingNewComponent,
                data: {
                    title: 'CNP Setting',
                    urls: [
                        {
                            title: 'CNP Setting',

                        },
                        {
                            title: 'CNP Setting'
                        }
                    ]
                }
            },
            // {
            //     path: 'addnew-campaign/:id',
            //     component: AddnewCampaignComponent,
            //     data: {
            //         title: 'New Campaign',
            //         urls: [
            //             {
            //                 title: 'New Campaign',

            //             },
            //             {
            //                 title: 'Addnew Campaign'
            //             }
            //         ]
            //     }
            // },
            {
                path: 'register_campaign',
                component: RegisternewCampaignComponent,
                data: {
                    title: 'Register a Campaign',
                    urls: [
                        {
                            title: 'Campaign',

                        },
                        {
                            title: 'Add Campaign'
                        }
                    ]
                }
            },

            {
                path: 'register_campaign/:id',
                component: RegisternewCampaignComponent,
                data: {
                    title: 'Register a Campaign',
                    urls: [
                        {
                            title: 'Campaign',

                        },
                        {
                            title: 'Add Campaign'
                        }
                    ]
                }
            },
            {
                path: 'campaigns',
                component: CampaignNewComponent,
                data: {
                    title: 'Campaigns',
                    urls: [
                        {
                            title: 'Campaign',

                        },
                        {
                            title: 'Campaign List'
                        }
                    ]
                }
            },
            {
                path: 'campaigns/:id',
                component: CampaignNewComponent,
                data: {
                    title: 'Add Campaign',
                    urls: [
                        {
                            title: 'Add Campaign',

                        },
                        {
                            title: 'Add Campaign'
                        }
                    ]
                }
            },
            {
                path: 'brand-details/:brandId',
                component: NewBrandDetailsComponent,
                data: {
                    title: 'Brands',
                    urls: [
                        {
                            title: 'Brand',

                        },
                        {
                            title: 'Brand details '
                        }
                    ]
                }
            },
            {
                path: 'campaign-details/:id',
                component: NewcampaignDetailsComponent,
                data: {
                    title: 'Campaigns',
                    urls: [
                        {
                            title: 'Campaign',

                        },
                        {
                            title: 'Campaign details '
                        }
                    ]
                }
            },
        ]
    }
];

@NgModule({
    imports: [RouterModule.forChild(routes)],
    exports: [RouterModule]
})
export class CampaignRoutingModule { }
